Attribute VB_Name = "dll_lib_GDI_API"
Option Explicit
    ' General:
    Declare Function GetWindowWord Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long) As Integer
        Public Const GWW_HINSTANCE = (-6)
        
    ' GDI object functions:
    Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
    Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
    Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
    Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
    Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
    Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
    Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
    Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
    Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
        Public Const BITSPIXEL = 12
        Public Const LOGPIXELSX = 88    '  Logical pixels/inch in X
        Public Const LOGPIXELSY = 90    '  Logical pixels/inch in Y
    ' System metrics:
    Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
        Public Const SM_CXICON = 11
        Public Const SM_CYICON = 12
        Public Const SM_CXFRAME = 32
        Public Const SM_CYCAPTION = 4
        Public Const SM_CYFRAME = 33
        Public Const SM_CYBORDER = 6
        Public Const SM_CXBORDER = 5
    
    ' Region paint and fill functions:
    Declare Function PaintRgn Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long) As Long
    Declare Function ExtFloodFill Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
        Public Const FLOODFILLBORDER = 0
        Public Const FLOODFILLSURFACE = 1
    
    ' Pen functions:
    Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
        Public Const PS_DASH = 1
        Public Const PS_DASHDOT = 3
        Public Const PS_DASHDOTDOT = 4
        Public Const PS_DOT = 2
        Public Const PS_SOLID = 0
        Public Const PS_NULL = 5
    
    ' Brush functions:
    Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
    Declare Function CreatePatternBrush Lib "gdi32" (ByVal hBitmap As Long) As Long
    
    ' Line functions:
    Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
    Type POINTAPI
            x As Long
            y As Long
    End Type
    Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, lpPoint As POINTAPI) As Long
    Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
        Public Const BF_LEFT = &H1
        Public Const BF_BOTTOM = &H8
        Public Const BF_RIGHT = &H4
        Public Const BF_TOP = &H2
        Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
        Public Const BDR_INNER = &HC
        Public Const BDR_OUTER = &H3
        Public Const BDR_RAISED = &H5
        Public Const BDR_RAISEDINNER = &H4
        Public Const BDR_RAISEDOUTER = &H1
        Public Const BDR_SUNKEN = &HA
        Public Const BDR_SUNKENINNER = &H8
        Public Const BDR_SUNKENOUTER = &H2
        Public Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
        Public Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
        Public Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
        Public Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
    
    ' Colour functions:
    Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
    Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
    Declare Function SetBkMode Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
        Public Const OPAQUE = 2
        Public Const TRANSPARENT = 1
    Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
        Public Const COLOR_ACTIVEBORDER = 10
        Public Const COLOR_ACTIVECAPTION = 2
        Public Const COLOR_ADJ_MAX = 100
        Public Const COLOR_ADJ_MIN = -100
        Public Const COLOR_APPWORKSPACE = 12
        Public Const COLOR_BACKGROUND = 1
        Public Const COLOR_BTNFACE = 15
        Public Const COLOR_BTNHIGHLIGHT = 20
        Public Const COLOR_BTNSHADOW = 16
        Public Const COLOR_BTNTEXT = 18
        Public Const COLOR_CAPTIONTEXT = 9
        Public Const COLOR_GRAYTEXT = 17
        Public Const COLOR_HIGHLIGHT = 13
        Public Const COLOR_HIGHLIGHTTEXT = 14
        Public Const COLOR_INACTIVEBORDER = 11
        Public Const COLOR_INACTIVECAPTION = 3
        Public Const COLOR_INACTIVECAPTIONTEXT = 19
        Public Const COLOR_MENU = 4
        Public Const COLOR_MENUTEXT = 7
        Public Const COLOR_SCROLLBAR = 0
        Public Const COLOR_WINDOW = 5
        Public Const COLOR_WINDOWFRAME = 6
        Public Const COLOR_WINDOWTEXT = 8
        Public Const COLORONCOLOR = 3
    
    ' Shell Extract icon functions:
    Declare Function FindExecutable Lib "shell32.dll" Alias "FindExecutableA" (ByVal lpFile As String, ByVal lpDirectory As String, ByVal lpResult As String) As Long
    Declare Function ExtractIcon Lib "shell32.dll" Alias "ExtractIconA" (ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long) As Long
    
    ' GDI icon functions:
    Declare Function DrawIcon Lib "user32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal hIcon As Long) As Long
    Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
    
    ' Blitting functions
    Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
        Public Const SRCCOPY = &HCC0020
        Public Const SRCINVERT = &H660046
        Public Const BLACKNESS = &H42
        Public Const WHITENESS = &HFF0062
        Public Const SRCAND = &H8800C6
        Public Const SRCERASE = &H440328
        Public Const SRCPAINT = &HEE0086
        
    Declare Function PatBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal dwRop As Long) As Long
    Declare Function LoadBitmapBynum Lib "user32" Alias "LoadBitmapA" (ByVal hInstance As Long, ByVal lpBitmapName As Long) As Long
    Type Bitmap
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Long
        bmBitsPixel As Integer
        bmBits As Long
    End Type
    Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
    Public Declare Function LoadImageByNum Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As Long, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
        Public Const LR_LOADMAP3DCOLORS = &H1000
        Public Const LR_LOADFROMFILE = &H10
        Public Const LR_LOADTRANSPARENT = &H20
        Public Const IMAGE_BITMAP = 0

    ' Text functions:
    Type RECT
        left As Long
        tOp As Long
        Right As Long
        Bottom As Long
    End Type
    Declare Function PtInRect Lib "user32" (lpRect As RECT, ByVal ptX As Long, ByVal ptY As Long) As Long
    Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
        Public Const DT_BOTTOM = &H8
        Public Const DT_CENTER = &H1
        Public Const DT_LEFT = &H0
        Public Const DT_CALCRECT = &H400
        Public Const DT_WORDBREAK = &H10
        Public Const DT_VCENTER = &H4
        Public Const DT_TOP = &H0
        Public Const DT_TABSTOP = &H80
        Public Const DT_SINGLELINE = &H20
        Public Const DT_RIGHT = &H2
        Public Const DT_NOCLIP = &H100
        Public Const DT_INTERNAL = &H1000
        Public Const DT_EXTERNALLEADING = &H200
        Public Const DT_EXPANDTABS = &H40
        Public Const DT_CHARSTREAM = 4
    Declare Function GrayString Lib "user32" Alias "GrayStringA" (ByVal hDC As Long, ByVal hBrush As Long, ByVal lpOutputFunc As Long, ByVal lpData As Long, ByVal nCount As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
    Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
    Declare Function DrawIconEx Lib "user32" (ByVal hDC As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Boolean
        Public Const DI_MASK = 1
        Public Const DI_IMAGE = 2
        Public Const DI_NORMAL = 3
        Public Const DI_COMPAT = 4
        Public Const DI_DEFAULTSIZE = 8

    Declare Function Rectangle Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long

    Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
        Public Const SW_SHOWNOACTIVATE = 4
    
    ' Scrolling and region functions:
    Declare Function ScrollDC Lib "user32" (ByVal hDC As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, lprcClip As RECT, ByVal hrgnUpdate As Long, lprcUpdate As RECT) As Long
    Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long
    Declare Function SelectClipRgn Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long) As Long
    Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
    Declare Function CreateRectRgnIndirect Lib "gdi32" (lpRect As RECT) As Long
    Declare Function CreatePolyPolygonRgn Lib "gdi32" (lpPoint As POINTAPI, lpPolyCounts As Long, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
    Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long)
    Declare Function SaveDC Lib "gdi32" (ByVal hDC As Long) As Long
    Declare Function RestoreDC Lib "gdi32" (ByVal hDC As Long, ByVal hSavedDC As Long) As Long

    Public Const LF_FACESIZE = 32
    Type LOGFONT
            lfHeight As Long
            lfWidth As Long
            lfEscapement As Long
            lfOrientation As Long
            lfWeight As Long
            lfItalic As Byte
            lfUnderline As Byte
            lfStrikeOut As Byte
            lfCharSet As Byte
            lfOutPrecision As Byte
            lfClipPrecision As Byte
            lfQuality As Byte
            lfPitchAndFamily As Byte
            lfFaceName(LF_FACESIZE) As Byte
    End Type
    Public Const FW_NORMAL = 400
    Public Const FW_BOLD = 700
    Public Const FF_DONTCARE = 0
    Public Const DEFAULT_QUALITY = 0
    Public Const DEFAULT_PITCH = 0
    Public Const DEFAULT_CHARSET = 1
    Declare Function CreateFontIndirect& Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT)
    Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long

